//---------------------------------------------------------------------------
// Copyright 2000 Andreas Huennebeck
//
// Licensed under the terms of the GNU General Public License.
// ABSOLUTELY NO WARRANTY. See the file `COPYING' in this distribution.
//
// $Source: /home/ah/CvsTree/daten/src/corr/corr.h,v $
// $Id: corr.h,v 1.2 2003/03/20 23:08:02 ah Exp $
//
// Description: convert time into readable string
//
//---------------------------------------------------------------------------

#ifndef AH_CORR_CORR_H		// prevent multiple includes
#define AH_CORR_CORR_H

// --- forward declarations ---

// --- necessary includes ---

#include <AH/Config/Platform.h>
#include <AH/Config/Types.h>
USING_NAMESPACE(AH)

// --- types and classes ---

BEGIN_NAMESPACE(AH)

#if 1
#define REF_TYPE_DOUBLE
#define IN_TYPE_DOUBLE
#define OUT_TYPE_DOUBLE
#endif
#if 0
#define REF_TYPE_BOOL
#define IN_TYPE_DOUBLE
#define OUT_TYPE_DOUBLE
#endif
#if 0
#define REF_TYPE_INT
#define IN_TYPE_INT
#define OUT_TYPE_INT
#endif
#if 0
#define REF_TYPE_BOOL
#define IN_TYPE_INT
#define OUT_TYPE_INT
#endif

#ifdef REF_TYPE_DOUBLE
typedef double corr_ref_t;
#endif
#ifdef REF_TYPE_INT
typedef int corr_ref_t;
#endif
#ifdef REF_TYPE_BOOL
typedef bool corr_ref_t;
#endif

#ifdef IN_TYPE_DOUBLE
typedef double corr_in_t;
#endif
#ifdef IN_TYPE_INT
typedef int corr_in_t;
#endif
#ifdef IN_TYPE_BOOL
typedef bool corr_in_t;
#endif

#ifdef OUT_TYPE_DOUBLE
typedef double corr_out_t;
#endif
#ifdef OUT_TYPE_INT
typedef int corr_out_t;
#endif


/// calculates a cross or autocorrelation
void correlate(const corr_ref_t* refbuf, const size_t refbuflen, 
	       const corr_in_t* inbuf, const size_t inbuflen,
	       corr_out_t* outbuf, const size_t outbuflen,
	       bool cyclic, int debon = 0);

END_NAMESPACE

#endif // !AH_CORR_CORR_H

