//---------------------------------------------------------------------------
// Copyright 1998 Andreas Huennebeck
//
// $Source: /home/ah/CvsTree/daten/src/include/AH/Etech/VisatonSpeakers.h,v $
// $Id: VisatonSpeakers.h,v 1.6 2001/10/05 23:44:27 ah Exp $
//
//---------------------------------------------------------------------------

#ifndef ETECH_VISATON_SPEAKERS_H	// prevent multiple includes
#define ETECH_VISATON_SPEAKERS_H

// --- necessary includes ---

#include <AH/Config/Platform.h>
#include <AH/Etech/Speaker.h>

USING_NAMESPACE(Ah)
BEGIN_NAMESPACE(Ah)

// --- forward declarations ---

class IntPol;

// --- types and classes ---


/// represents the speaker VISATON SC 10
/**
 {\tt Visaton\_SC\_10} represents the 25 mm dome tweeter SC 10 which is 
 made by Visaton.
 */
class Visaton_SC_10: public Speaker
{
  private:
    static IntPol* splCurve;

  public:
    /// default constructor
    Visaton_SC_10();

    /// destructor
    virtual ~Visaton_SC_10() {}

    /// get acoustic power level dB/W/m at specified frequency
    virtual Dbl getSpl(Dbl freq) const;
};


END_NAMESPACE

#endif // ETECH_VISATON_SPEAKERS_H
