//---------------------------------------------------------------------------
// Copyright 1999 Andreas Huennebeck
//
// Licensed under the terms of the GNU General Public License.
// ABSOLUTELY NO WARRANTY. See the file `COPYING' in this distribution.
//
// $Source: /home/ah/CvsTree/daten/src/include/AH/IO/Riff/Error.h,v $
// $Id: Error.h,v 1.2 2004/03/15 20:58:09 ah Exp $
//
// Description: 
//
//---------------------------------------------------------------------------

#ifndef AH_IO_RIFF_ERROR_H		// prevent multiple includes
#define AH_IO_RIFF_ERROR_H

// --- forward declarations ---

// --- necessary includes ---

#include <AH/Config/Platform.h>
#include <AH/IO/Error.h>
USING_NAMESPACE(AH)

// --- types and classes ---

BEGIN_NAMESPACE(AH)

/// unspecified Riff IO error
class ErrorIORiff: public ErrorIO
{
  public:
    /// default constructor
    ErrorIORiff() : ErrorIO("RIFF IO error") {}
    /// constructor
    ErrorIORiff(const string& m) : ErrorIO(m) {};
    /// copy constructor
    ErrorIORiff(const ErrorIORiff& src) : ErrorIO(src) {}
    /// assignment operator:
    const ErrorIORiff& operator=(const ErrorIORiff& src)
	{
	    if (&src != this)
	    {
		ErrorIO::operator=(src);
	    }
	    return *this;
	}
    /// destructor
    virtual ~ErrorIORiff() throw () {}
};

class ErrorIORiffInvalidFormat: public ErrorIORiff
{
 public:
    /// default constructor
    ErrorIORiffInvalidFormat() 
	: ErrorIORiff("invalid RIFF file format") {}
    /// constructor
    ErrorIORiffInvalidFormat(const string& m) 
	: ErrorIORiff(m) {};
    /// copy constructor
    ErrorIORiffInvalidFormat(const ErrorIORiffInvalidFormat& src) 
	: ErrorIORiff(src) {}
    /// assignment operator:
    const ErrorIORiffInvalidFormat& operator=
	(const ErrorIORiffInvalidFormat& src)
	{
	    if (&src != this)
	    {
		ErrorIORiff::operator=(src);
	    }
	    return *this;
	}
    /// destructor
    virtual ~ErrorIORiffInvalidFormat() throw () {}
};


class ErrorIORiffInvalidWaveFormat: public ErrorIORiffInvalidFormat
{
 public:
    /// default constructor
    ErrorIORiffInvalidWaveFormat()
        : ErrorIORiffInvalidFormat("invalid WAVE file format") {}
    /// constructor
    ErrorIORiffInvalidWaveFormat(const char* err)
	: ErrorIORiffInvalidFormat(err) {}
    /// copy constructor
    ErrorIORiffInvalidWaveFormat(const ErrorIORiffInvalidWaveFormat& src) 
	: ErrorIORiffInvalidFormat(src) {}
    /// assignment operator:
    const ErrorIORiffInvalidWaveFormat& operator=
	(const ErrorIORiffInvalidWaveFormat& src)
	{
	    if (&src != this)
	    {
		ErrorIORiffInvalidFormat::operator=(src);
	    }
	    return *this;
	}

    /// destructor
    virtual ~ErrorIORiffInvalidWaveFormat() throw () {}
};

END_NAMESPACE

#endif // !AH_IO_RIFF_ERROR_H
