//---------------------------------------------------------------------------
// Copyright 1998 Andreas Huennebeck
//
// $Source: /home/ah/CvsTree/daten/src/libAHetech/Cd.c,v $
// $Id: Cd.c,v 1.3 2001/10/05 23:44:26 ah Exp $
//
// Description: implementation of CD de/emphasis calculation
//
//---------------------------------------------------------------------------

static const char rcsid[] = "$Id: Cd.c,v 1.3 2001/10/05 23:44:26 ah Exp $ (c) 1998 Andreas Huennebeck";

// --- necessary includes ---

#include <AH/Config/Platform.h>
#include <AH/Etech/Cd.h>
#include <AH/Etech/MathConst.h>

USING_NAMESPACE(Ah)
BEGIN_NAMESPACE(Ah)

// --- global function implementation ---

Cplx CdDeEmphasis(Dbl f)
{
    Dbl t1(50e-6);
    Dbl t2(15e-6);

    Cplx n(1, 2 * MathConst::Pi * f * t1);
    Cplx z(1, 2 * MathConst::Pi * f * t2);
    Cplx Ua2Ue = z / n;

    return (Ua2Ue);
}


Cplx CdPreEmphasis(Dbl f)
{
    Dbl t1(50e-6);
    Dbl t2(15e-6);

    Cplx n(1, 2 * MathConst::Pi * f * t1);
    Cplx z(1, 2 * MathConst::Pi * f * t2);
    Cplx Ua2Ue = n / z;

    return (Ua2Ue);
}

END_NAMESPACE
