//---------------------------------------------------------------------------
// Copyright 1998 Andreas Huennebeck
//
// $Source: /home/ah/CvsTree/daten/src/libAHetech/ClosedBox.c,v $
// $Id: ClosedBox.c,v 1.4 2001/10/05 23:44:26 ah Exp $
//
// Description: implementation of class ClosedBox
//
//---------------------------------------------------------------------------

static const char rcsid[] = "$Id: ClosedBox.c,v 1.4 2001/10/05 23:44:26 ah Exp $ (c) 1998 Andreas Huennebeck";

// --- necessary includes ---

#include <AH/Config/Platform.h>
#include <AH/Etech/ClosedBox.h>
#include <AH/Etech/Speaker.h>

USING_NAMESPACE(Ah)

BEGIN_NAMESPACE(Ah)

// --- local stuff ---

// --- class member implementation ---


// constructor
ClosedBox::ClosedBox(Speaker& s, Dbl q, bool d, const char* n) 
    : Box(s,n), Qt(q), damped(d) 
{
}


// calculate parameters: box volume, resonance frequency, lower limit
void ClosedBox::calc(Dbl& Vb, Dbl& Fr, Dbl& F3) const
{
    Dbl Qtc = 1.0 / (1.0/Qt + 1.0/(damped ? 5 : 10));
    Dbl alpha = Qtc/sp.getQt(); alpha *= alpha; alpha -= 1;
    Vb = sp.getVa() / alpha;
    Fr = sp.getFres() * sqrt(alpha + 1);
    Dbl a1 = 1.0 / (Qtc * Qtc) - 2;
    F3 = Fr * sqrt((a1 + sqrt(a1 * a1 + 4)) / 2.0);
}

// --- overloaded operators ---

// --- friend functions ---

END_NAMESPACE
