//---------------------------------------------------------------------------
// Copyright 1997 Andreas Huennebeck
//
// Licensed under the terms of the GNU General Public License.
// ABSOLUTELY NO WARRANTY. See the file `COPYING' in this distribution.
//
// $Source: /home/ah/CvsTree/daten/src/libAHstl/Del.c,v $
// $Id: 
//
// Description: 
//
//---------------------------------------------------------------------------

static const char cvsid[] = "$Id: Del.c,v 1.4 2003/03/18 01:00:14 ah Exp $ (c) 1997 Andreas Huennebeck";

// --- necessary includes ---

#include <AH/STL/String.h>
USING_NAMESPACE(AH)

BEGIN_NAMESPACE(AH)

void STLStringDelFollow
(
    string&	line,
    const char*	remove
)
{
    string::size_type pos = line.find_last_not_of(remove);
    if (string::npos != pos)
	line = line.substr(0, pos+1);
    else
    {
	// check for string containing only removable characters
	pos = line.find_first_of(remove);
	if (string::npos != pos)
	    line.erase();
    }
}



void STLStringDelLead
(
    string&	line,
    const char*	remove
)
{
    string::size_type pos(line.find_first_not_of(remove));
    if (string::npos != pos)
	line = line.substr(pos);
    else
    {
	// check for string containing only removable characters
	pos = line.find_first_of(remove);
	if (string::npos != pos)
	    line.erase();
    }
}


END_NAMESPACE





